debug = true
require("tiles")
require("items")
require("units")
require("rooms")
--Data
gConfig = {}	--Gameconfig
gConfig.full = false ; gConfig.screens = 1
gConfig.music = true ; gConfig.mVol = 100
gConfig.sound = true ; gConfig.sVol = 100
gConfig.autosave = true ; gConfig.lang = "en.lng"

cConfig	= {}	--Controlls
cConfig[0] = 'w' ; cConfig[1] = 'W'
cConfig[2] = 's' ; cConfig[3] = 'S'
cConfig[4] = 'a' ; cConfig[5] = 'A'
cConfig[6] = 'd' ; cConfig[7] = 'D'

scene = 19
quit = false

roomselect = 0
unitselect = 0
		
--Functions
function intro()

end



--Main
function love.load(arg)
	gConfig.screens = love.window.getDisplayCount()
	if gConfig.full == true then
		love.window.setMode(640, 480, {fullscreen = true})
	else
		love.window.setMode(640, 480, {fullscreen = false})
	end
	
	fontA = love.graphics.newFont('pcsenior.ttf', 24)

	for i = 0, #tiles, 1 do		--Tile Constructor
		tiles[i].sprite = love.graphics.newImage(tiles[i].image)
	end
	
	
	love.physics.setMeter(16)
	level = {}
	for i = 0, 48, 1 do		--Maximum 48 Rooms
		level[i] = {}
		level[i].collider = {}
		level[i].glow = {}
		level[i].typeof = {}
		level[i].world = love.physics.newWorld(0, 0, true)
	end
	roomConstruct(0, 0)
	
	
	for i = 0, #units, 1 do		--Unit Constructor
		units[i].sprite = love.graphics.newImage(units[i].image)
		--Physics of AI and Player
		units[i].body = love.physics.newBody(level[roomselect].world, units[unitselect].x, units[unitselect].y, "dynamic") --Creating Physical Body
		units[i].shape = love.physics.newRectangleShape(16, 16)		--Set Shape of Body
		units[i].fixture = love.physics.newFixture(units[unitselect].body, units[unitselect].shape, 0.2)	--Object Density
		units[i].fixture:setRestitution(0.1)	--Object Bouncing
		units[i].body:setAngularDamping(units[i].damp)		--Rotation Damping
		units[i].body:setLinearDamping(units[i].damp/2)
	end
	
	
	for i = 0, #items, 1 do 	--Item Constructor
		--!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	end
end

function love.update(dt)
	if scene == 0 then			--Intro
	
	elseif scene == 1 then			--Main Menu
	
	elseif scene == 19 then			--Game Init
		roomselect = 0
		unitselect = 0
		
		scene = 20
	elseif scene == 20 then 		--In-Game
		--Generate Speed
		checkW = love.keyboard.isDown(cConfig[0],cConfig[1])
		checkS = love.keyboard.isDown(cConfig[2],cConfig[3])
		checkA = love.keyboard.isDown(cConfig[4],cConfig[5])
		checkD = love.keyboard.isDown(cConfig[6],cConfig[7])
		
		
		if checkA == true then
			units[unitselect].body:applyTorque(-units[unitselect].rotspeed)
		end
		if checkD == true then
			units[unitselect].body:applyTorque(units[unitselect].rotspeed)
		end

						--moveX = (100/90)*units[unitselect].rotation
			--moveY = 100-moveX
		local forceX = ((100/360)*math.deg(units[unitselect].body:getAngle()))*units[unitselect].accleration
		local forceY = units[unitselect].accleration-forceX
		if checkW == true then
			local angle = math.deg(units[unitselect].body:getAngle())
			if angle < 90 then
				units[unitselect].body:applyForce(forceX, -forceY)
			elseif angle < 180 then
				units[unitselect].body:applyForce(forceX, forceY)
			elseif angle < 270 then
				units[unitselect].body:applyForce(-forceX, forceY)
			elseif angle < 360 then
				units[unitselect].body:applyForce(-forceX, -forceY)
			end
		end
		if checkS == true then
			angle = math.deg(units[unitselect].body:getAngle())
			if angle < 90 then
				units[unitselect].body:applyForce(-forceX, forceY)
			elseif angle < 180 then
				units[unitselect].body:applyForce(-forceX, -forceY)
			elseif angle < 270 then
				units[unitselect].body:applyForce(forceX, -forceY)
			elseif angle < 360 then
				units[unitselect].body:applyForce(forceX, forceY)
			end
		end
		
		
		level[roomselect].world:update(dt)
	end
end

function love.draw(dt)
	if scene == 0 then				--Intro
	
	elseif scene == 1 then				--Main Menu
	
	elseif scene == 19 then
	
	elseif scene == 20 then			--In-Game
		love.graphics.draw(level[roomselect].image, 0, 0)
		love.graphics.draw(units[unitselect].sprite, units[unitselect].body:getX(), units[unitselect].body:getY(), units[unitselect].body:getAngle(), 1, 1, 8, 8)
	end
end

function love.quit()
	love.event.quit()
end

function roomConstruct(i,j)	--level Number, Room Number
	level[i].image = love.graphics.newCanvas(rawRoom[j].x*16, rawRoom[j].y*16)
	love.graphics.setCanvas(level[i].image)
	for q = 0, rawRoom[j].y-1, 1 do
		for z = 1, rawRoom[j].x, 1 do
			love.graphics.draw(tiles[rawRoom[j].tiles[q*rawRoom[j].x+z]].sprite, (z-1)*16,q*16)
		end
	end
	love.graphics.setCanvas()
end